package cn.estsh.i3plus.ext.mes.pcn.api.busi.jx;

import cn.estsh.i3plus.ext.mes.pcn.pojo.model.jx.JxProdBusiStrategyParamsBuilder;
import cn.estsh.i3plus.ext.mes.pcn.pojo.util.MesPcnExtConstWords;
import cn.estsh.i3plus.pojo.mes.model.StepResult;
import io.swagger.annotations.ApiOperation;

public interface IJxProdBusiStrategyService {

    /**
     * 上线验证
     * @param params 参数
     * @return 结果
     */
    @ApiOperation(value = "上线验证", notes = "上线验证")
    StepResult checkLineOn(JxProdBusiStrategyParamsBuilder params);

    /**
     * 从管理码开始查询业务数据
     * @param params 参数
     * @return 结果
     */
    @ApiOperation(value = "从管理码开始查询业务数据", notes = "从管理码开始查询业务数据")
    default JxProdBusiStrategyParamsBuilder queryBusiData4Mc(JxProdBusiStrategyParamsBuilder params) { return params; }

    /**
     * 从产品条码开始查询业务数据
     * @param params 参数
     * @return 结果
     */
    @ApiOperation(value = "从产品条码开始查询业务数据", notes = "从产品条码开始查询业务数据")
    default JxProdBusiStrategyParamsBuilder queryBusiData4Ps(JxProdBusiStrategyParamsBuilder params) { return params; }

    /**
     * 查询产品条码业务数据
     * @param params 参数
     * @return 结果
     */
    @ApiOperation(value = "查询产品条码业务数据", notes = "查询产品条码业务数据")
    default JxProdBusiStrategyParamsBuilder queryProduceSnInfo(JxProdBusiStrategyParamsBuilder params) { return params; }

    /**
     * 查询管理码业务数据
     * @param params 参数
     * @return 结果
     */
    @ApiOperation(value = "查询管理码业务数据", notes = "查询管理码业务数据")
    default JxProdBusiStrategyParamsBuilder queryManageCodeInfo(JxProdBusiStrategyParamsBuilder params) { return params; }

    /**
     * 获取生产工单已绑数据
     * @param params 参数
     * @return 结果
     */
    @ApiOperation(value = "获取生产工单已绑数据", notes = "获取生产工单已绑数据")
    default Integer queryOrderBindedQty(JxProdBusiStrategyParamsBuilder params) { return MesPcnExtConstWords.ZERO; }

}
